/* UpTools v8.6
 *
 * Copyright (c) 2005-2011 Fundacion Universidad de Palermo (Argentina).
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment: 'This product includes software developed by the
 *    "Universidad de Palermo, Argentina" (http://www.palermo.edu/).'
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include <UpTools/UpNaptrQuery.h>
#include <iostream>

using namespace std;

int main() {
	int i=0;
	for(int j=0; j<100;j++) {
		UpResolver res;
		UpResolver* r2 = new UpResolver;
		UpNaptrQuery* q1 = new UpNaptrQuery("lab.up", "sips:nacho@labcom.com:5060;user=phone", "SIPS+D2T");
		UpNaptrQuery* q2 = new UpNaptrQuery("palermo.edu", "sip:nach@palermo.edu:5060;user=phone", "SIP+D2T");
		UpNaptrQuery q3("palermo.edu", "sip:nacho@palermo.edu:5060;user=phone","SIP+D2T");
		UpNaptrQuery q4("lab.up", "sip:nacho@labcom.com:5060;user=phone", "SIPS+D2T");
		res.query(*q1);
		r2->query(*q2);
		res.query(q3);
		r2->query(q4);
		do {
        	q1->waitCompletion();
			q2->waitCompletion();
			q3.waitCompletion();
			q4.waitCompletion();
    	} while( q1->getNStatus()<SNAPTR_COMPLETE_OK && q4.getNStatus()<SNAPTR_COMPLETE_OK );
		q3.cancel();
		
		cout << "New Uri Query"<<i<<"(heap): " << q1->getNewUri() << endl; 	i++;
		cout << "New Uri Query"<<i<<"(heap): " << q2->getNewUri() << endl; 	i++;
		cout << "New Uri Query"<<i<<"(stack): " << q3.getNewUri() << endl; i++;
		cout << "New Uri Query"<<i<<"(stack): " << q4.getNewUri() << endl; i++;
		delete q1;
		delete q2;
		r2->cancel();
		r2->join();
		res.cancel();
		res.join();
		delete r2;
		//sleep(1);

	}
	return 0;
}
