/* UpTools v8.6
 *
 * Copyright (c) 2005-2011 Fundacion Universidad de Palermo (Argentina).
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment: 'This product includes software developed by the
 *    "Universidad de Palermo, Argentina" (http://www.palermo.edu/).'
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <UpTools/UpCondition.h>
#include<iostream>
using namespace std;

class T : public UpThread {
	private:
		UpCondition<>& c;
	public:
		T(UpCondition<>&_c)	: c(_c) {
			 create(); // start thread
		}

		void*	run() {
			c.lock(); // safe zone for c.var
				while( c.var<5 ) { // test condition
					cout<<"thread "<<pthread_self()
						<<": c.var dos not meet condition, let's wait..."<<endl;
					c.wait(); // release c and wait for signal... relock c on return
					cout<<"thread "<<pthread_self()
						<<": signalled, lets check condition..."<<endl;
				}
				cout<<"thread "<<pthread_self()
					<<": condition met!... exiting thread"<<endl;
			c.unlock();
			return 0;
		}
};

int main() {
	UpCondition<int> c(0);
	T t(c);
	int aux;
	do {
		c.lock(); // safe zone for c.var
			aux = ++c.var;
			cout<<"thread "<<pthread_self()<<": c.var="<<c.var<<endl;
			c.signal();
		c.unlock();
		sleep(1);
	} while( aux<10 );
	
	t.join();
	return 0;

}
