/* UpTools v8.6
 *
 * Copyright (c) 2005-2011 Fundacion Universidad de Palermo (Argentina).
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment: 'This product includes software developed by the
 *    "Universidad de Palermo, Argentina" (http://www.palermo.edu/).'
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <iostream>
#include <UpTools/UpResolverSimple.h>
#include <UpTools/UpInet.h>


using namespace std;

//////////////////////////////////////////////////////////////////////////////////////////////
// Test con 1 resolver Asyncronico
int main() {
	cout << "UpResolverSimple: blocking resolver test" << endl << endl;

	UpResolverSimple resolv; 
	
	UpDnsQuerySimple q0("www.google.com",ns_t_a);
	UpDnsQuerySimple q1("palermo.edu",ns_t_naptr);
	UpDnsQuerySimple q2("intel.com",ns_t_mx);
	UpDnsQuerySimple q3("www.palermo.edu",ns_t_a);
	UpDnsQuerySimple q4;

	cout<<"Querying domain ..."<<resolv.query(q0)<<'\n'<<q0<<'\n'<<endl;
	cout<<"Querying domain ..."<<resolv.query(q1)<<'\n'<<q1<<'\n'<<endl;
	cout<<"Querying domain ..."<<resolv.query(q2)<<'\n'<<q2<<'\n'<<endl;
	cout<<"Querying domain ..."<<resolv.query(q3)<<'\n'<<q3<<'\n'<<endl;
	UpAddress up;
	q3.resetGetNext();
	for(;;) {
		const UpResourceRecord& rp( q3.getNext() );
		if(rp.getType()==ns_t_a ) {
			q4.set(rp.getAddr());
			break;
		}
		if( rp.getType()==ns_t_invalid ) break;
	}
	cout<<"Querying domain ..."<<resolv.query(q4)<<'\n'<<q4<<'\n'<<endl;

	return 0;
}
