/* UpTools v8.6
 *
 * Copyright (c) 2005-2011 Fundacion Universidad de Palermo (Argentina).
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment: 'This product includes software developed by the
 *    "Universidad de Palermo, Argentina" (http://www.palermo.edu/).'
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include<UpTools/UpTimerManager.h>
#include<iostream>
using namespace std;

class MyTimer : public UpTimer {
	private:
		string msg;
	public:
		MyTimer(const UpTimeVal& _when, const UpTimeVal& _interval,
				  unsigned int _repeatCount, const string& s)
		: UpTimer(_when,_interval,_repeatCount,"MyTimer"),msg(s) {}

		bool action(const UpTimeVal& _now) { 
			cout<<"\nMyTimer::action count:"<<count<<" msg:"<<msg<<endl;
			return true;
		}
		~MyTimer() {
			cout<<"(MyTimer::destructor msg:"<<msg<<") "<<endl; 
		}
};

class YourTimer : public UpTimer {
	private:
		string msg;
	public:
		YourTimer(const UpTimeVal& _when, const UpTimeVal& _interval,
				  unsigned int _repeatCount, const string& s)
		: UpTimer(_when,_interval,_repeatCount,"YourTimer"),msg(s) {}

		bool action(const UpTimeVal& _now) { 
			cout<<"\nYourTimer::action count:"<<count<<" msg:"<<msg<<endl;
			return true;
		}
		~YourTimer() {
			cout<<"(YourTimer::destructor msg:"<<msg<<") "<<endl; 
		}
};

int main() {

	UpTimerManager tm;
	tm.startThread();
	tm.setTickInterval(0.5);
	//1º cuando empieza ,   2º intervalo,   3º cuantas veces 4º mensaje
	MyTimer* ta=new MyTimer( tm.now()+(time_t)1, 1, 3,    "timer a");
	MyTimer* tb=new MyTimer( tm.now()+(time_t)2, 2, 5,    "timer b");
	YourTimer* tc=new YourTimer( tm.now()+(time_t)3, 3, 2,    "timer c");
	tm.add(ta);
	tm.add(tb);
	tm.add(tc);

	cout<<"\nReport:\n";tm.report(cout);
	sleep(5);
	cout<<"\nReport:\n";tm.report(cout);
	sleep(10);
	cout<<"\nReport:\n";tm.report(cout);
	return 0;
}







